  org 100h     ; assume ax=bx=0 cx=0xff si=0x100

  mov di,0x330
  mov dx,di

U lodsb        ; unpack 100,101,102... -> 330,332,334...
  aam 0x10     ; hhhhllll -> al=0000llll ah=0000hhhh
  stosw
  loop U

P mov si,NOTES
  call PLAY

  push bx
  and bx,0xf
  mov si,DRUMS
  call PLAY
  pop bx

  push bx
  shr bx,1
  jc NM
  shr bx,1
  jc NM
  mov si,MELODY
  call PLAY
NM:
  pop bx

  inc bx
  and bx,0x3f

  hlt
  hlt
  hlt

  in al,0x60
  dec al
  jnz P

PLAY:
  outsb  ; program change
  outsb

  lodsw  ; ah = transposition
  out dx,al ; play/stop
;  outsb  

  add si,si
  lea si,[si+bx+0x130+1]

  lodsb
  add al,ah
  out dx,al   ; stop old note
  salc   ; al=0
  out dx,al

  cmp al,[si] ; 0=rest
  jz R

  lodsb
  add al,ah
  out dx,al   ; play new note
  mov al,0x7f
  out dx,al
R ret

%define w(l,h) (l)+(h)*0x10


%define C 48   -47
%define D 50   -47
%define S 51   -47  ; D# = es
%define E 52   -47
%define F 53   -47
%define G 55   -47
%define A 57   -47
%define B 58   -47
%define H 59   -47
%define c 48+12-47
%define d 50+12-47
%define _ 0

NOTES:
db 0xc0,90, 0x90, 47  ; channel 1 - polysynth
db w(_,A)
db w(d,E),w(G,H),w(c,d), w(c,H),w(G,E), w(d,E),w(G,H),w(c,d),
db w(d,S),w(G,B),w(c,d), w(c,B),w(G,S), w(d,S),w(G,B),w(c,d),
db w(c,D),w(F,A),w(B,c), w(B,A),w(F,D), w(c,D),w(F,A),w(B,c),
db w(A,C),w(D,F),w(G,A), w(G,F),w(D,C), w(A,C),w(D,F),w(G,A),

;db 4,0,1,2,3,4, 3,2,1,0, 4,0,1,2,3,4,
;db E,G,H,c,d,
;db S,G,B,c,d,
;db D,F,A,B,c,
;db C,D,F,G,A,

MELODY:
db 0xc1,103, 0x91, 47+12 ; channel 2 - star theme
db w(_,_)
db w(H,_),w(_,c), w(d,_),w(_,B), w(A,_),w(_,G), w(C,F),w(_,_),


%define B 36-35 ; bass drum 1
%define S 40-35 ; electric snare
%define H 44-35 ; pedal hi-hat
%define O 46-35 ; open hi-hat

DRUMS:
db 0xc9,16, 0x99, 35 ; channel 10 - power kit
db w(_,S)
db w(B,H),w(O,H), w(S,H),w(O,B), w(H,B),w(B,H), w(S,H),w(O,S)
