  org 100h     ; assume ax=bx=0 cx=0xff si=0x100

  mov di,0x330
  mov dx,di

U lodsb        ; unpack 100,101,102... -> 330,332,334...
  aam 0x10     ; hhhhllll -> al=0000llll ah=0000hhhh
  stosw
  loop U

P push bx
 
  and bx,0x3f
  mov si,NOTES
  call PLAY

  and bx,0xf
  mov si,DRUMS
  call PLAY
  
  pop bx

  push bx
  shr bx,1
  jc N
  shr bx,1
  jc N
  mov si,MELODY
  call PLAY
N pop bx

  inc bl
  
  hlt
  hlt
  hlt

  in al,0x60
  dec al
  jnz P

PLAY:
  lodsw  ; al = 0xc0 + channel (program change)
         ; ah = transposition
  out dx,al
  outsb
  add al,0x90-0xc0 ; al = 0x90 + channel (play/stop note)
  out dx,al

  add si,si
  lea si,[si+bx+0x130-1]

  lodsb
  add al,ah
  out dx,al   ; stop old note
  salc   ; al=0
  out dx,al

  cmp al,[si] ; 0=rest
  jz R

  lodsb
  add al,ah
  out dx,al   ; play new note
  mov al,0x7f
  out dx,al

NOTES:
R ret  ; 0xc3

%define w(l,h) (l)+(h)*0x10

%define C 48   -47
%define D 50   -47
%define S 51   -47  ; D# = es
%define E 52   -47
%define F 53   -47
%define G 55   -47
%define A 57   -47
%define B 58   -47
%define H 59   -47
%define c 48+12-47
%define d 50+12-47
%define _ 0

;db 0xc3, 47, 90  ; channel 4 - polysynth
db 47, 90  ; channel 4 - polysynth
db w(_,E),w(G,H),w(c,d), w(c,H),w(G,E), w(d,E),w(G,H),w(c,d),  ; Cmaj/D
db w(_,S),w(G,B),w(c,d), w(c,B),w(G,S), w(d,S),w(G,B),w(c,d),  ; Cm7/D
db w(_,D),w(F,A),w(B,c), w(B,A),w(F,D), w(c,D),w(F,A),w(B,c),  ; Bmaj/C
db w(_,C),w(D,F),w(G,A), w(G,F),w(D,C), w(A,C),w(D,F),w(G,_),  ; G7sus4/A

;db _,0,1,2,3,4, 3,2,1,0, 4,0,1,2,3,4,
;db E,G,H,c,d,
;db S,G,B,c,d,
;db D,F,A,B,c,
;db C,D,F,G,A,

MELODY:
db 0xc1, 47+12, 103 ; channel 2 - star theme
db w(_,H),w(_,d), w(c,B),w(A,G), w(_,F),w(_,c), w(B,A),w(G,F),
db w(_,E),w(_,H), w(B,_),w(c,d), w(A,_),w(_,F), w(C,_),w(G,A),
db w(H,_),w(_,c), w(d,_),w(_,G), w(A,_),w(_,B), w(c,_),w(D,F),
db w(G,_),w(d,c), w(G,_),w(F,S), w(D,F),w(c,B), w(A,_),w(_,_),

%define B 36-35 ; bass drum 1
%define S 40-35 ; electric snare
%define H 44-35 ; pedal hi-hat
%define O 46-35 ; open hi-hat

DRUMS:
db 0xc9, 35, 16 ; channel 10 - power kit
db w(B,H),w(O,B), w(S,H),w(O,B), w(H,B),w(B,H), w(S,H),w(O,S)
