  org 100h     ; assume ax=bx=0 cx=0xff si=0x100

  mov di,0xa000 - 255*2

U lodsb        ; unpack 100,101,102... -> 330,332,334...
  aam 0x10     ; hhhhllll -> al=0000llll ah=0000hhhh
  stosw
  loop U

  ; ah=0 after unpack
  mov ax,13h
P imul cx,bx,0xc1
  xchg ch,cl
  int 10h      ; cl=blue = i, ch=green = i/2
  mov ax,0x1010
  dec bl       ; bl=i = 255 (index: we use 63..0)
  jnz P
  
  mov es,di


M mov dx,0x330

  push bx

  and bx,0x3f  ; 64 notes
  mov si,NOTES
  call PLAY

  and bx,0xf   ; 16 drums
  mov si,DRUMS
  call PLAY

  pop bx

  push bx      ; 0,4,8,12...252 (also 64 notes)
  shr bx,1
  jc NN
  shr bx,1
  jc NN
  mov si,MELODY
  call PLAY
NN:
  pop bx

  mov cx,3
ANIM:
X:mov ax,0xcccd
  mul di
  
  add dx,0xa080
  
  xor ax,ax

LX:
  xor al,7*4;15*2
  neg dl
  jl LX        ; 0..128

LY:
  xor al,3*4;7*2
  neg dh
  jl LY

  cmp dl,dh
  jb L
  xor al,1*4;3*2
  xchg dl,dh
L:

;  shr dh,1
;
;  cmp dl,dh
;  jb Q
;  xor al,1*2
  
;  add dh,dl
;  shr dh,1

;  shr dl,1
;  add dl,dh
;  push ax
;  mov al,181
;  mul dl
;  xchg ax,dx
;  pop ax
Q:
  add al,4
  test al,8
  jz H
  shr dl,1
  add dh,dl

;  shr dl,1
;  add dl,dh
;  push ax
;  mov al,181
;  mul dl
;  xchg ax,dx
;  pop ax

H:

  add dh,cl
  shr dh,2
  sub dh,bl
  add al,dh
  
  and al,0x1f
  jnz E
  mov al,0x3f
E:
  stosb
  
  or di,di
  jnz X
  
  hlt
  loop ANIM

  inc bl

  in al,0x60
  dec al
  jnz M

PLAY:
  lodsw  ; al = 0xc0 + channel (program change)
         ; ah = transposition
  out dx,al
  outsb
  add al,0x90-0xc0 ; al = 0x90 + channel (play/stop note)
  out dx,al

  add si,si
  lea si,[si-0x200+bx+ 0xa000-255*2 -1]

  lodsb
  add al,ah
  out dx,al   ; stop old note
  salc   ; al=0
  out dx,al

  cmp al,[si] ; 0=rest
  jz R

  lodsb
  add al,ah
  out dx,al   ; play new note
  mov al,0x7f
  out dx,al

NOTES:
R ret  ; 0xc3

%define w(l,h) (l)+(h)*0x10

%define C 48   -47
%define D 50   -47
%define S 51   -47  ; D# = es
%define E 52   -47
%define F 53   -47
%define G 55   -47
%define A 57   -47
%define B 58   -47
%define H 59   -47
%define c 48+12-47
%define d 50+12-47
%define _ 0

%define b 36-35 ; bass drum 1
%define s 40-35 ; electric snare
%define h 44-35 ; pedal hi-hat
%define o 46-35 ; open hi-hat


;db 0xc3, 47, 90  ; channel 4 - polysynth
db 47, 90  ; channel 4 - polysynth
db w(_,E),w(G,H),w(c,d), w(c,H),w(G,E), w(d,E),w(G,H),w(c,d),  ; Cmaj/D
db w(_,S),w(G,B),w(c,d), w(c,B),w(G,S), w(d,S),w(G,B),w(c,d),  ; Cm7/D
db w(_,D),w(F,A),w(B,c), w(B,A),w(F,D), w(c,D),w(F,A),w(B,c),  ; Bmaj/C
db w(_,C),w(D,F),w(G,A), w(G,F),w(D,C), w(A,C),w(D,F),w(G,_),  ; G7sus4/A

;db _,0,1,2,3,4, 3,2,1,0, 4,0,1,2,3,4,
;db E,G,H,c,d,
;db S,G,B,c,d,
;db D,F,A,B,c,
;db C,D,F,G,A,

DRUMS:
db 0xc9, 35, 16 ; channel 10 - power kit
db w(b,h),w(o,b), w(s,h),w(o,b), w(h,b),w(b,h), w(s,h),w(o,s)

MELODY:
db 0xc1, 47+12, 103 ; channel 2 - star theme
db w(_,H),w(_,d), w(c,B),w(A,G), w(_,F),w(_,c), w(B,A),w(G,F),
db w(_,E),w(_,H), w(B,_),w(c,d), w(A,_),w(_,F), w(C,_),w(G,A),
db w(H,_),w(_,c), w(d,_),w(_,G), w(A,_),w(_,B), w(c,_),w(D,F),
db w(G,_),w(d,c), w(G,_),w(F,S), w(D,F),w(c,B), w(A,_),w(_,_),
