  org 100h     ; assume ax=bx=0 cx=0xff si=0x100

%define DI_INIT 0xa000 - 255*2

  mov di,DI_INIT

U lodsb        ; unpack 100,101,102... -> 330,332,334...
  aam 0x10     ; hhhhllll -> al=0000llll ah=0000hhhh
  stosw
  loop U

  ; ah=0 after unpack?
  mov ax,13h
P imul cx,bx,0xc1
  xchg ch,cl
  int 10h      ; cl=blue = i, ch=green = i*0.75
  mov ax,0x1010
  dec bl       ; bl=i = 255 (index: we use 63..0)
  jnz P

  mov es,di

M:

  mov cx,12
ANIM:
X:mov ax,0xcccd
  mul di

  add dx,0xa080

  xor ax,ax

LX:
  xor al,7*4;15*2
  neg dl
  jl LX        ; 0..128

LY:
  xor al,3*4;7*2
  neg dh
  jl LY

  cmp dl,dh
  jb L
  xor al,1*4;3*2
  xchg dl,dh
L:

;  shr dh,1
;
;  cmp dl,dh
;  jb Q
;  xor al,1*2

Q:
  sub al,4
  test al,8
  jnz H
  shr dl,1
  add dh,dl
H:

  add dh,cl
  shr dh,4
  sub dh,bl
  add al,dh

  and al,0x1f
  jnz E
  mov al,0x3f
E:
  stosb

  test di,di
  jnz X

; wait for retrace
  mov dx,0x3da
W in al,dx
  test al,8   ; cf=0
  jz W
  
;  call SCREENSHOT

  loop ANIM

MUSIC:
  mov dl,0x30  ; dx=0x330

  mov si,NOTES
;  clc
CHN:
  pusha

  jb SKIPQUARTER

  shr bx,1
  jc NN
  shr bx,1
  jc NN
;  test bl,dh  ; 3
;  jnz NN
;  shr bl,2


SKIPQUARTER:
  call PLAY
NN:
  popa
  
  add si,32+4
  cmp si,DRUMS+1
  jb CHN

  inc bl

  in al,0x60
  dec al
  jnz M

PLAY:
  lodsw  ; al = 0xc0 + channel (program change)
         ; ah = transposition
  out dx,al
  outsb
  add al,0x90-0xc0 ; al = 0x90 + channel (play/stop note)
  out dx,al
  
  lodsb
  and bl,al

  add si,si
  lea si,[si-0x200+bx+DI_INIT-1]

PLUS:
  lodsb
  cmp al,0
  jz SKIP
  add al,ah
  out dx,al   ; stop old note/play new note
  mov al,ch
  out dx,al
SKIP:
  xor ch,0x7f
  jnz PLUS

NOTES:
  ret  ; 0xc3

%define w(l,h) (l)+(h)*0x10

%define C 48   -47
%define D 50   -47
%define S 51   -47  ; D# = es
%define E 52   -47
%define F 53   -47
%define G 55   -47
%define A 57   -47
%define B 58   -47
%define H 59   -47
%define c 48+12-47
%define d 50+12-47
%define _ 0

%define b 36-35 ; bass drum 1
%define s 40-35 ; electric snare
%define h 44-35 ; pedal hi-hat
%define o 46-35 ; open hi-hat

MELODY:
;db 0xc3
db 47+12, 103, 0x3f    ; channel 4 - star theme
db w(_,H),w(_,d), w(c,B),w(A,G), w(_,F),w(_,c), w(B,A),w(G,F),
db w(_,E),w(_,H), w(B,_),w(c,d), w(A,_),w(_,F), w(C,_),w(G,A),
db w(H,_),w(_,c), w(d,_),w(_,G), w(A,_),w(_,B), w(c,_),w(D,F),
db w(G,_),w(d,c), w(G,_),w(F,S), w(D,F),w(c,B), w(A,_),w(_,_),

HARMONY:
db 0xc1, 47, 90, 0x3f  ; channel 2 - polysynth
db w(_,E),w(G,H),w(c,d), w(c,H),w(G,E), w(d,E),w(G,H),w(c,d),  ; Cmaj/D
db w(_,S),w(G,B),w(c,d), w(c,B),w(G,S), w(d,S),w(G,B),w(c,d),  ; Cm7/D
db w(_,D),w(F,A),w(B,c), w(B,A),w(F,D), w(c,D),w(F,A),w(B,c),  ; Bmaj/C
db w(_,C),w(D,F),w(G,A), w(G,F),w(D,C), w(A,C),w(D,F),w(G,_),  ; G7sus4/A

DRUMS:
db 0xc9, 35, 16, 0x0f ; channel 10 - power kit
db w(b,h),w(o,b), w(s,h),w(o,b), w(h,b),w(b,h), w(s,h),w(o,s)

db 0

; %include "screenshot.inc"
